package goaml.lang.process;

import java.util.Hashtable;
import java.util.List;

import goaml.lang.StateChart;
import goaml.lang.state.State;
import goaml.lang.util.DelayedUpdate;

public final class IL2Production extends AbstractProcess {

	private State il2Maker;
	private State il2;
	private double rate;

	public IL2Production() {
	}

	private IL2Production(final State il2Maker, final State il2, final double rate) {
		this.il2Maker = il2Maker;
		this.il2 = il2;
		this.rate = rate;
	}

	@Override
	protected void createProcess(StateChart stateChart, Hashtable<String, List<State>> inputsOuputs,
			Hashtable<String, Double> values) {

		List<State> il2Makers = null;
		List<State> il2s = null;
		double rate = 0.0;

		if (inputsOuputs.containsKey("il2Maker")) {
			il2Makers = inputsOuputs.get("il2Maker");
		} else {
			throw new RuntimeException("Input \"il2Maker\" missed in " + this.getClass() + " process");
		}
		if (inputsOuputs.containsKey("il2")) {
			il2s = inputsOuputs.get("il2");
		} else {
			throw new RuntimeException("Input \"il2\" missed in " + this.getClass() + " process");
		}
		
		if (values.containsKey("rate")) {
			rate = values.get("rate");
		} else {
			throw new RuntimeException("Value \"rate\" missed in " + this.getClass() + " process");
		}

		for (State il2Maker : il2Makers) {
			for (State il2 : il2s) {
				stateChart.addProcess(new IL2Production(il2Maker, il2, rate));
			}
		}
	}

	@Override
	public void compute(final StateChart stateChart) {
		double amount = this.il2Maker.getValue() * this.rate;

		// Create DelayedUpdates in order to apply computed value on the states when all transitions
		// and processes have compute
		stateChart.addDelayedUpdate(new DelayedUpdate(this.il2, DelayedUpdate.Action.ADD, amount));
	}

}
